define([
  'jquery',
  'underscore', 
  'backbone',
  'views/mapview',
  'views/fusionview'
  ], function($, _, Backbone, MapView, FusionView){
  var AppView = Backbone.View.extend({

    // Instead of generating a new element, bind to the existing skeleton of
    // the App already present in the HTML.
    el: $("#map-app"),


    // Delegated events for creating new items, and clearing completed ones.
    events: {
      //"click #new-todo-button":  "createOnEnter",
    },
    layers : [],
    
    initialize: function() {
        this.map_canvas = this.$("#map-canvas");
        this.layers_control = this.$("#layers-control");
        
        this.map_view = new MapView;
        this.map_canvas.append(this.map_view.render().el);
        
        this.fusion_view = new FusionView;
        this.fusion_view.bind('tableCheckEvent',this.handleLayerChange,this);
        this.layers_control.append(this.fusion_view.render().el);
    },

    render: function() {

    },
    
    handleLayerChange: function(e){
        var table = e.table;
        var column = e.column;
        if(e.target.checked){
            var layer = _.find(this.layers,function(obj){
                return obj.id == table.tableId;
            });
            if (!layer){
                var layer = new google.maps.FusionTablesLayer({
                    id: table.tableId,
                    query: {
                        select: column,
                        from: table.tableId
                        },
                    });
                layer.setMap(this.map_view.map);
                this.layers.push(layer)
            } else{
                layer.setMap(this.map_view.map);
            }
        } else {
            var layer = _.find(this.layers,function(obj){
                return obj.id == table.tableId;
            });
            layer.setMap(null);
        }
    }

  });
  return AppView;
});