define(['jquery',
        'underscore', 
        'backbone', 
        'text!templates/fusionpanel.html',
        'text!templates/layer.html',
        'gapi'],
function($, _, Backbone, fusionPanelTemplate, layerTemplate, gapi) {
    var FusionView = Backbone.View.extend({

        tagName: "div",
        className: "fusionLayerControls",

        template: _.template(fusionPanelTemplate),
        layerTemplate: _.template(layerTemplate),
        
        tables: [],
        
        config: {
            'client_id': '1052388990162.apps.googleusercontent.com',
            'scope': 'https://www.googleapis.com/auth/fusiontables',
            'immediate': true
        },
        apiKey: 'AIzaSyBKJfTa5cjz8h9FtP0L57wt_glrj7OLMWY',

        events: {
            "click #authorize-button": "authButtonClick",
            "click .table-check": "tableCheckChange"
        },

        initialize: function() {
            _.bindAll(this,'authResult','handleAuthorized', 
                      'authButtonClick', 'handleTableList','tableCheckChange');
            gapi.client.setApiKey(this.apiKey);
            gapi.client.fusionview = this;
        },

        render: function() {
            $(this.el).html(this.template());
            gapi.auth.authorize(this.config, this.authResult);
            return this;
        },

        authButtonClick: function() {
            this.config.immediate = false;
            gapi.auth.authorize(this.config, this.authResult);
        },

        authResult: function(authResult,callback) {
            if (authResult && !authResult.error) {
                this.$('#authorize-button').hide();
                gapi.client.load('fusiontables', 'v1', this.handleAuthorized);
            }
            else {
                $('#authorize-button').show();
            }
        },
        handleAuthorized: function() {
            gapi.client.fusiontables.table.list().execute(this.handleTableList);
        },
        
        handleTableList: function(response){
            this.tables = response.items;
            for (var i = 0; i < response.items.length;i++){
              var item = response.items[i];
              var view = this.layerTemplate(item);
              var panel = $(this.el).children("#layers-panel");
              panel.append(view);
            }
        },

        tableCheckChange: function(e) {
            var table = _.find(this.tables,function(obj){
                return obj.tableId == e.target.id;
            });
            e.table = table;
            var column = $(e.target).siblings('#'+table.tableId +'-select');
            e.column = $(column[0]).val();
            this.trigger('tableCheckEvent', e);
        }

    });
    return FusionView;
});